/*
 * postal_flock.c
 * flock() lock a file
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_flock.c,v 1.2 2001/11/30 13:47:54 fullermd Exp $
 */

#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/file.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>

/*
 * These should be something other than global vars someday,
 * if we want to ever be threadsafe.
 */

int flock_wait=1;
int flock_retry=5;

int
postal_flock(int tolock, int type)
{
	int count=0;

	while( (flock(tolock, (type|LOCK_NB) )!=0) )
	{
		if(errno!=EWOULDBLOCK)
		{
			/* We need an error handling system */
			return(1);
		}
		
		/*
		 * EWOULDBLOCK implies that somebody else already
		 * holds the lock.
		 * Wait and try again, unless we've already exceeded
		 * the number of retries.
		 */
		if(count>=flock_retry)
			return(1);

		count++;
		usleep(flock_wait);
	}
	
	/* If we got here, flock succeeded */
	return(0);
}
