/*
 * postal_get_header.c
 * Get a specified header from a POSTAL_MSG
 * libpostal project
 * libpost_raw gen code
 * $Id: postal_get_header.c,v 1.2 2001/12/25 16:07:11 fullermd Exp $
 */

#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>


char *
postal_get_header(POSTAL_MSG *p_msg, const char *toget)
{
	char *toret, *hdrwork, *buf, *buf2;
	int nxtfnd=0;

	hdrwork = malloc(strlen(p_msg->header)+1);
	strcpy(hdrwork, p_msg->header);

	if( (buf=strcasestr(hdrwork, toget)) )
	{
		/*
		 * Header found.  Find the next header.
		 * Don't just do a strchr() for \n!  Headers
		 * may span lines!
		 */
		buf2 = strchr(buf, '\n');
		while(nxtfnd==0)
		{
			if(!buf2)
			{
				/*
				 * No \n found.  Assume it's the last header in the
				 * group, and run with it.
				 */
				nxtfnd=1;
			}
			else if(isalpha(*(buf2+1)))
			{
				/* This is the end of the header */
				*buf2='\0';
				nxtfnd=1;
			}
			else
			{
				/* Try again */
				buf2 = strchr(buf2, '\n');
			}
		}
	}
	else
	{
		/* Header isn't found */
		return(NULL);
	}

	/*
	 * We've now got a full null-terminated header at
	 * buf.  Chop off the titular portion of the header
	 * and slap it into the var to return.
	 */
	buf += strlen(toget);
	/* Whack leading spaces */
	while(*buf==' ')
		buf++;
	toret = malloc(strlen(buf)+1);
	strcpy(toret, buf);
	free(hdrwork);
	return(toret);
}
