/*
 * mbox_get_message_all.c
 * Get all messages from a mbox
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_get_message_all.c,v 1.4 2001/12/25 16:58:46 fullermd Exp $
 */

#include <stdlib.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>

/* # of message slots to allocate at once */
#define	ALLOC_CHUNK		128


POSTAL_MSG_GROUP *
mbox_get_message_all(POSTAL_CONN *p_conn, int get_type)
{
	POSTAL_MSG_GROUP *toret;
	POSTAL_MSG *p_msg;
	long alloced=0;

	toret = malloc(PMSGGROUP_SIZE);
	toret->num_msgs=0;	/* Better safe... */

	/* We need to start at the beginning of the file of course */
	lseek(p_conn->spec.mbox->desc, 0, SEEK_SET);

	/* Read in a message at a time until we're done */
	while( (p_msg = mbox_get_message_next(p_conn, get_type)) )
	{
		toret->num_msgs++;

		if(alloced < (toret->num_msgs))
		{
			/*
			 * We need to allocate more space.
			 * We're doing it in chunks of ALLOC_CHUNK.
			 */
			toret->msgs = realloc( toret->msgs,
					(sizeof(POSTAL_MSG *) * (alloced + ALLOC_CHUNK)) );
			alloced += ALLOC_CHUNK;
		}

		/* We've got a message, add it in */
		(toret->msgs)[(toret->num_msgs-1)] = p_msg;
	}

	/* Prune the memory.  This is a bit dicey. */
	toret->msgs = realloc( toret->msgs,
			(sizeof(POSTAL_MSG *) * (toret->num_msgs)) );

	/* Return our big structure */
	return(toret);
}
