/*
 * mbox_get_status.c
 * Get status info from a mbox-derived message
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_get_status.c,v 1.1 2001/12/25 13:40:18 fullermd Exp $
 */

#include <stdlib.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>


int
mbox_get_status(POSTAL_MSG *msg)
{
	char *hdrs;
	int statae;

	/* Find the Status: header and copy it down locally */
	hdrs = postal_get_header(msg, "Status:");
	if(hdrs)
	{
		/* 'O' means 'old' */
		if(strchr(hdrs, 'O'))
			statae |= STATUS_OLD;
	
		/* 'R' means 'read' */
		if(strchr(hdrs, 'R'))
			statae |= STATUS_READ;

		free(hdrs);
	}

	/*
	 * Try X-Status: too, a number of mailers (mutt, pine, etc) use it
	 * too.
	 */
	hdrs = postal_get_header(msg, "X-Status:");
	if(hdrs)
	{
		/* 'A' means 'replied to' */
		if(strchr(hdrs, 'A'))
			statae |= STATUS_REPLIED;

		/* There are some others, but I don't think they really matter */

		free(hdrs);
	}

	return(statae);
}
