/*
 * mbox_lock_write.c
 * Lock an mbox for writing ('exclusive')
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_lock_write.c,v 1.3 2001/12/01 19:13:23 fullermd Exp $
 */

#include <sys/file.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>


int
mbox_lock_write(POSTAL_CONN *mbox, int locks)
{
	/*
	 * Check the lock types and execute.
	 * This is our canonical order.
	 */

	/* flock() */
	if( (locks & LOCK_FLOCK) &&
		!(mbox->spec.mbox->locks & LOCK_FLOCK_EX) )
	{
		if( (postal_flock(mbox->spec.mbox->desc, LOCK_EX)!=0) )
		{
			/* Something went wrong */
			return(1);
		}
		/* Note that we're flock()-locked exclusively */
		mbox->spec.mbox->locks |= (LOCK_FLOCK | LOCK_FLOCK_EX);
	}

	/* No other locktypes defined yet */

	/* If we got here, everything succeeded */
	return(0);
}
