/*
 * mbox_unlock.c
 * Unlock a mbox
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_unlock.c,v 1.3 2001/12/01 16:49:06 fullermd Exp $
 */

#include <sys/file.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>


int
mbox_unlock(POSTAL_CONN *mbox)
{
	/*
	 * Check the lock types and execute.
	 * This is our canonical order.
	 */

	/* Are we flock()'d? */
	if( (mbox->spec.mbox->locks & LOCK_FLOCK) )
	{
		if( (postal_flock(mbox->spec.mbox->desc, LOCK_UN)!=0) )
		{
			/* Something went wrong */
			return(1);
		}
		/* Note that we're flock()-unlocked */
		mbox->spec.mbox->locks &= ~(LOCK_FLOCK | LOCK_FLOCK_EX);
	}

	/* No other locktypes defined yet */

	/* If we got here, everything succeeded */
	return(0);
}
