/*
 * listfrom.c
 * Test mbox reading functions
 * Specially designed to work in the compile tree
 * Links again: libpost_raw
 * Links shared
 * $Id: listfrom.c,v 1.3 2001/12/25 16:57:45 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "../../include/post_raw/post_raw.h"


int
main(int argc, char *argv[])
{
	POSTAL_CONN *my_conn;
	POSTAL_MSG_GROUP *msgs;
	POSTAL_MSG *msgtmp;
	long i;
	char *ret_hdr, *ret_hdr2;
	int stat;
	char stats[128]; /* Wasteful.  Who cares. */

	if(argc<2)
	{
		printf("Need mbox name, damn you!\n");
		exit(1);
	}

	argc--;
	argv++;

	printf("Running on (presumed) mbox '%s'\n", *argv);

	my_conn=mbox_open_file(*argv, LOCK_FLOCK, OPEN_READONLY);

	if(!my_conn)
	{
		printf("Error opening mailbox '%s'.  Oopsie.\n", *argv);
		exit(1);
	}

	/* Get all the headers */
	msgs = mbox_get_message_all(my_conn, GET_HEADER);

	/* For each message, list msg #, size, status, and From: header */
	for(i=1 ; i <= postal_mgroup_num(msgs) ; i++)
	{
		msgtmp = postal_mgroup_getmsg(msgs, i);
		ret_hdr = postal_get_header(msgtmp, "From:");
		ret_hdr2 = postal_get_header(msgtmp, "Message-Id:");
		stat = mbox_get_status(msgtmp);
		bzero(stats, 128);
		if(stat&STATUS_OLD)
			strcat(stats, "Old ");
		if(stat&STATUS_READ)
			strcat(stats, "Read ");
		if(stat&STATUS_REPLIED)
			strcat(stats, "Answered ");
		printf("#%-5li %6li bytes, Status: %s\n\t\tFrom: '%s'\n"
				"\t\tMessage-Id: '%s'\n",
				i, postal_msg_size(msgtmp), stats, ret_hdr, ret_hdr2);
		free(ret_hdr);
		free(ret_hdr2);
	}

	exit(0);
}
