#!/usr/bin/perl -w
# makemakefiles.pl
# Written for the libpostal project
# $Id: mkmakefiles.pl,v 1.5 2001/11/08 13:52:12 fullermd Exp $

# Make bmake-style Makefiles and gmake-style GNUmakefiles
# from a .proto makefile.
# This is severely ugly, and inefficient to boot.  Too bad.
# You think you can do it better, then *PLEASE* do.

use Cwd;

# We're given the full path to the .proto Makefile as the sole
# command-line argument
$protofile = $ARGV[0];
chomp $protofile;

# Figure out where the base of the libpostal tree is, so we can
# figure out where mkdep (and other files we'll need) are.
# Again, ugly, but I don't know of a better way.
# Do some heuristics based on how we were called.
$iam = $0;
$_ = $iam;
while(!(/\.\.$/))
{
	chop;
}
$lpdir = $_;

# Figure out what our makefiles are
# Don't try this at home, kids...
$bname = $protofile;
for($i=0 ; $i<=5 ; $i++)
{	chop $bname;	}
$bmakefile = $gmakefile = $bname;
$gmakefile =~ s/Makefile/GNUmakefile/;

# Now lets get conversions going...
# Our input
open(PROTO, "$protofile");
open(BMAKE, ">$bmakefile");
open(GMAKE, ">$gmakefile");
while(<PROTO>)
{
	chomp;
	$inline = $_;
	# Now the fun begins
	# Chop out all the comment lines...
	next if $inline =~ /^#/;

	# Clean more comment stuff
	$inline =~ s/#.*$//;

	# Now, let's see if it's one of our 'special' tags
	if( $inline =~ /^MKVARDEFS/ )
	{
		# Put in the variable definitions that we want...
		unlink("${lpdir}/tools/defs\.out");
		open(VDEF, "$lpdir/tools/progdefs");
		while(<VDEF>)
		{
			# Holy crap, this is ugly.  Oh well.
			chomp;
			# Ignore comment line
			if(/^#/)
			{	next;	}
			($vname, $pname) = split /\=/;
			system("echo -n $vname = >> $lpdir/tools/defs.out");
			system("$lpdir/tools/findprog.sh $pname >> $lpdir/tools/defs.out");
		}
		close VDEF;
		open(DOUT, "$lpdir/tools/defs\.out");
		while(<DOUT>)
		{
			print BMAKE $_;
			print GMAKE $_;
		}
		close DOUT;
		unlink("$lpdir/tools/defs.out");

		print BMAKE "MKDEP = $lpdir/tools/mkdep\n";
		print GMAKE "MKDEP = $lpdir/tools/mkdep\n";
		next;
	}

	if( $inline =~ /^ADD_DEPEND/ )
	{
		# Add the dependancy include in the GNU makefile
		print GMAKE "-include \${.CURDIR}/.depend\n";
		next;
	}

	if( $inline =~ /^CURDIR_SUB/ )
	{
		# Yet another thing we only have to do for GNU Makefiles...
		print GMAKE ".CURDIR = \${PWD}\n";
		next;
	}

	# Now, start the subs
	$bmake = $gmake = $inline;

	# INCLUDE()
	$bmake =~ s/INCLUDE\(([^\)]+)\)/\.include\ \"$1\"/;
	$gmake =~ s/INCLUDE\(([^\)]+)\)/include\ $1/;
	$gmake =~ s/Makefile/GNUmakefile/;

	# NOTDIR
	$bmake =~ s/NOTDIR\(([^\)]+)\}\)/$1:T\}/;
	$gmake =~ s/NOTDIR\(([^\)]+)\}\)/\$\(notdir\ $1\}\)/;

	# A few variable usages
	$gmake =~ s/\.TARGET/\@/g;
	$gmake =~ s/\.IMPSRC/\</g;

	# Write out the line
	print BMAKE "$bmake\n";
	print GMAKE "$gmake\n";
	# Fin
}
close(PROTO);
close(BMAKE);
close(GMAKE);
